Kea: isc::dhcp::SanityChecksParser Class Reference

| Kea 3.2.0-git

isc::dhcp::SanityChecksParser Class Reference

Simple parser for sanity-checks structure. More...

`#include <sanity_checks_parser.h>`

Inheritance diagram for isc::dhcp::SanityChecksParser:
[legend]

## Public Member Functions
void | parse (SrvConfig &srv_cfg, const isc::data::ConstElementPtr &value)
| parses JSON structure
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
template<typename T>
static void | rangeCheckedInteger (isc::data::ConstElementPtr scope, const std::string &name, T &output_value)
| Fetches a range-checked integer parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Detailed Description

Simple parser for sanity-checks structure.

Currently parses only one parameter:

- lease-checks. Allowed values: none, warn, fix, fix-del, del

Definition at line 20 of file sanity_checks_parser.h.

## Member Function Documentation

## ◆ parse()

void isc::dhcp::SanityChecksParser::parse | ( | SrvConfig & | srv_cfg,
|  | const isc::data::ConstElementPtr & | value )

parses JSON structure

Parameters

  srv_cfg | parsed value will be stored here
  value | a JSON map that contains lease-checks parameter.

Definition at line 18 of file sanity_checks_parser.cc.

References isc::dhcp::CfgConsistency::EXTENDED_INFO_CHECK_FIX, isc::dhcp::CfgConsistency::EXTENDED_INFO_CHECK_NONE, isc::dhcp::CfgConsistency::EXTENDED_INFO_CHECK_PEDANTIC, isc::dhcp::CfgConsistency::EXTENDED_INFO_CHECK_STRICT, isc::dhcp::SrvConfig::getConsistency(), isc_throw, isc::dhcp::CfgConsistency::LEASE_CHECK_DEL, isc::dhcp::CfgConsistency::LEASE_CHECK_FIX, isc::dhcp::CfgConsistency::LEASE_CHECK_FIX_DEL, isc::dhcp::CfgConsistency::LEASE_CHECK_NONE, isc::dhcp::CfgConsistency::LEASE_CHECK_WARN, isc::data::Element::map, and isc::data::Element::string.

Referenced by isc::dhcp::processDhcp4Config(), and isc::dhcp::processDhcp6Config().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- sanity_checks_parser.h
- sanity_checks_parser.cc